# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Compress-Raw-Zlib
# EL ≥ 6 has Epoch: 1; no other distros have it
%if "%{__distinit}" == "rhel" && %{__distvers} > 5
Epoch:		1
%endif
Version:	2.074
Release:	1.%{__distinit}%{__distvers}
Summary:	Low-level interface to the zlib compression library
# Zlib.xs: (GPL+ or Artistic) and zlib
# Others:  GPL+ or Artistic
License:	(GPL+ or Artistic) and zlib
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Compress-Raw-Zlib/
Source0:	http://search.cpan.org/CPAN/authors/id/P/PM/PMQS/Compress-Raw-Zlib-%{version}.tar.gz
Source1:	old_zlib.c
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	perl
%if 0%{?fedora} > 6 || 0%{?rhel} > 5
BuildRequires:	perl-devel
%endif
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
BuildRequires:	perl(Config)
BuildRequires:	perl(ExtUtils::Constant)
BuildRequires:	perl(ExtUtils::Install)
BuildRequires:	perl(ExtUtils::MakeMaker) >= 5.16
BuildRequires:	perl(File::Copy)
BuildRequires:	perl(File::Spec::Functions)
BuildRequires:	perl(lib)
BuildRequires:	perl(vars)
BuildRequires:	zlib-devel
# Module Runtime
BuildRequires:	perl(bytes)
BuildRequires:	perl(Carp)
BuildRequires:	perl(constant)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
BuildRequires:	perl(XSLoader)
# Test Suite
BuildRequires:	perl(File::Path)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(lib)
BuildRequires:	perl(overload)
# Dual-lived module needs rebuilding early in the boot process
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(Test::NoWarnings)
BuildRequires:	perl(Test::Pod) >= 1.00
%endif
BuildRequires:	perl(threads::shared)
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(XSLoader)

# Don't "provide" private Perl libs
%{?perl_default_filter}

%description
The Compress::Raw::Zlib module provides a Perl interface to the zlib
compression library, which is used by IO::Compress::Zlib.

%prep
%setup -q -n Compress-Raw-Zlib-%{version}
cp %{SOURCE1} .

%build
# We need zlib ≥ 1.2.1; if the system one is too old, use the bundled one
make old_zlib CFLAGS="%{optflags}"
if ./old_zlib; then
OLD_ZLIB=False
BUILD_ZLIB=True
ZLIB_LIB=./zlib-src
ZLIB_INCLUDE=./zlib-src
else
OLD_ZLIB=False
BUILD_ZLIB=False
ZLIB_LIB=%{_libdir}
ZLIB_INCLUDE=%{_includedir}
fi
export BUILD_ZLIB OLD_ZLIB ZLIB_LIB ZLIB_INCLUDE
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}

%check
make test COMPRESS_ZLIB_RUN_MOST=1

%clean
rm -rf %{buildroot}

%files
%doc Changes README
%{perl_vendorarch}/auto/Compress/
%{perl_vendorarch}/Compress/
%{_mandir}/man3/Compress::Raw::Zlib.3*

%changelog
* Mon Feb 20 2017 Paul Howarth <paul@city-fan.org> - 2.074-1
- Update to 2.074
  - Zlib.xs: comment out unused variables and remove C++-ism (CPAN RT#120272)

* Mon Feb 13 2017 Paul Howarth <paul@city-fan.org> - 2.072-1
- Update to 2.072
  - Fix for Makefile.PL depending on . in @INC (CPAN RT#120084)
  - inflateUndermine: subvert arg conditionally used/unused (CPAN RT#120207)
  - Fix two gcc6-found problems in bundled zlib (CPAN RT#112829)
  - Fix deflateParams for zlib > 1.2.8
  - Tests were broken with zlib-1.2.10 (CPAN RT#119762)

* Sat Dec 31 2016 Paul Howarth <paul@city-fan.org> - 2.071-1
- Update to 2.071
  - One (last?) compilation warning in bundled inflate.c (CPAN RT#119580,
    https://github.com/madler/zlib/issues/111)

* Thu Dec 29 2016 Paul Howarth <paul@city-fan.org> - 2.070-1
- Update to 2.070
  - Fix compilation warning from inflate.c (CPAN RT#107642)
  - Fix wrong FLAG_APPEND logic, analog to Bzip2 (CPAN RT#119007)

* Wed Aug 10 2016 Paul Howarth <paul@city-fan.org> - 2.069-366
- BR: perl-generators where available
- Simplify find commands using -empty and -delete

* Sun Sep 27 2015 Paul Howarth <paul@city-fan.org> - 2.069-1
- Update to 2.069
  - Reduce compiler warnings and stderr noise (CPAN RT#101341)
  - amigaos4: cpan/Compress-Raw-Zlib: also __amigaos4__ (CPAN RT#106799)
  - const all global data (CPAN RT#101298)
  - Coverity finding: Unused value (CPAN RT#105414)
  - Coverity findings (CPAN RT#102399)
  - Coverity finding: Overlapping buffer in memory copy (CPAN RT#105413)

* Wed Dec 24 2014 Paul Howarth <paul@city-fan.org> - 2.068-1
- Update to 2.068
  - Silence more compiler warnings
  - Disable running of 07bufsize.t by default; COMPRESS_ZLIB_RUN_MOST needs to
    be set to run it, which makes life more bearable on legacy platforms

* Tue Dec  9 2014 Paul Howarth <paul@city-fan.org> - 2.067-1
- Update to 2.067 (silence compiler warnings)
- Classify buildreqs by usage

* Mon Sep 22 2014 Paul Howarth <paul@city-fan.org> - 2.066-1
- Update to 2.066
  - Another COW violation (CPAN RT#98069)
  - Misleading nesting/indentation found by Coverity (CPAN RT#95405)

* Wed Sep  3 2014 Paul Howarth <paul@city-fan.org> - 2.065-310
- Increase release to favour standalone package

* Tue Sep  2 2014 Paul Howarth <paul@city-fan.org> - 2.065-4
- Perl 5.20 rebuild

* Fri Apr 25 2014 Paul Howarth <paul@city-fan.org> - 2.065-2
- EL-7 builds need Epoch:1, like EL-6 builds
- Drop %%defattr, redundant since rpm 4.4

* Tue Feb  4 2014 Paul Howarth <paul@city-fan.org> - 2.065-1
- Update to 2.065
  - Resolve c++ build failure in core (CPAN RT#92657)
  - gcc -g3: final link failed: Memory exhausted (CPAN RT#88936)

* Sun Feb  2 2014 Paul Howarth <paul@city-fan.org> - 2.064-1
- Update to 2.064
  - Handle non-PVs better (CPAN RT#91558)
  - Z_OK instead of Z_BUF_ERROR (CPAN RT#92521)

* Sun Nov  3 2013 Paul Howarth <paul@city-fan.org> - 2.063-1
- Update to 2.063
  - gcc -g3: final link failed: Memory exhausted (CPAN RT#88936)
  - Compress::Raw::Zlib uses AutoLoader for no reason (CPAN RT#88260)
  - Typo in Compress::Zlib _combine function documentation (CPAN RT#89305)

* Mon Aug 12 2013 Paul Howarth <paul@city-fan.org> - 2.062-1
- Update to 2.062
  - Typo fix (CPAN RT#86417)

* Thu Jul 18 2013 Paul Howarth <paul@city-fan.org> - 2.061-2
- Perl 5.18 rebuild

* Mon May 27 2013 Paul Howarth <paul@city-fan.org> - 2.061-1
- Update to 2.061
  - Include zlib 1.2.8 source
  - Typo fix (CPAN RT#85431)
  - Silence compiler warning by making 2nd parameter to DispStream a const char*

* Tue Jan  8 2013 Paul Howarth <paul@city-fan.org> - 2.060-1
- Update to 2.060 (mention SimpleZip in POD)

* Sun Nov 25 2012 Paul Howarth <paul@city-fan.org> - 2.059-1
- Update to 2.059
  - Copy-on-write support (CPAN RT#81353)

* Tue Nov 13 2012 Paul Howarth <paul@city-fan.org> - 2.058-1
- Update to 2.058 (no changes)

* Sat Nov 10 2012 Paul Howarth <paul@city-fan.org> - 2.057-1
- Update to 2.057
  - Compress::Raw::Zlib needs to use PERL_NO_GET_CONTEXT (CPAN RT#80319)
  - Install to 'site' instead of 'perl' when perl version is 5.11+
    (CPAN RT#79812)
  - Update to ppport.h that includes SvPV_nomg_nolen (CPAN RT#78079)

* Sat Aug 11 2012 Paul Howarth <paul@city-fan.org> - 2.056-1
- Update to 2.056
  - Fix C++ build issue

* Mon Aug  6 2012 Paul Howarth <paul@city-fan.org> - 2.055-1
- Update to 2.055
  - Fix misuse of magic in API (CPAN RT#78079)
  - Include zlib 1.2.7 source
- Don't BR: perl(Test::Pod) when bootstrapping

* Wed Jul 11 2012 Paul Howarth <paul@city-fan.org> - 2.054-4
- Bump Epoch to 1 for EL-6 only (#801804)

* Tue Jun 19 2012 Paul Howarth <paul@city-fan.org> - 2.054-3
- BR: perl(lib)
- BR: perl(Test::NoWarnings) if we're not bootstrapping

* Tue May  8 2012 Paul Howarth <paul@city-fan.org> - 2.054-1
- Update to 2.054
  - Fix build issue on Win32 (CPAN RT#77030)

* Sun May  6 2012 Paul Howarth <paul@city-fan.org> - 2.053-1
- Update to 2.053
  - Include zlib 1.2.7 source

* Sun Apr 29 2012 Paul Howarth <paul@city-fan.org> - 2.052-1
- Update to 2.052
  - Fix build issue when Perl is built with C++
- Don't need to remove empty directories from buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorarch}
  - Use %%{_fixperms} macro rather than our own chmod incantation
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Thu Feb 23 2012 Paul Howarth <paul@city-fan.org> - 2.051-1
- Update to 2.051
  - Fix bug in Compress::Raw::Zlib on 64-bit Windows (CPAN RT#75222)
- Add buildreqs for Perl core modules that might be dual-lived

* Tue Feb 21 2012 Paul Howarth <paul@city-fan.org> - 2.050-1
- Update to 2.050
  - Fix build failure on Irix and Solaris (CPAN RT#75151)

* Sat Feb 18 2012 Paul Howarth <paul@city-fan.org> - 2.049-1
- Update to 2.049
  - Include zlib 1.2.6 source

* Sun Jan 29 2012 Paul Howarth <paul@city-fan.org> - 2.048-1
- Update to 2.048 (set minimum zlib version to 1.2.0)

* Sun Jan 29 2012 Paul Howarth <paul@city-fan.org> - 2.047-1
- Update to 2.047
  - Allow flush to be called multiple times without any intermediate call to
    deflate and still return Z_OK
  - Added support for zlibCompileFlags
  - Set minimum Perl version to 5.6

* Sun Dec  4 2011 Paul Howarth <paul@city-fan.org> - 2.045-1
- Update to 2.045
  - Moved FAQ.pod into Zlib.pm

* Sun Dec  4 2011 Paul Howarth <paul@city-fan.org> - 2.044-1
- Update to 2.044
  - Moved FAQ.pod under the lib directory so it can get installed

* Mon Nov 21 2011 Paul Howarth <paul@city-fan.org> - 2.043-1
- Update to 2.043 (no changes)

* Fri Nov 18 2011 Paul Howarth <paul@city-fan.org> - 2.042-1
- Update to 2.042 (no changes)

* Sat Oct 29 2011 Paul Howarth <paul@city-fan.org> - 2.040-1
- Update to 2.040 (no changes)

* Fri Oct 28 2011 Paul Howarth <paul@city-fan.org> - 2.039-1
- Update to 2.039
  - Croak if attempt to freeze/thaw compression object (CPAN RT#69985)
- BR: perl(Carp)

* Wed Jun 22 2011 Paul Howarth <paul@city-fan.org> - 2.037-2
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Wed Jun 22 2011 Paul Howarth <paul@city-fan.org> - 2.037-1
- Update to 2.037 (no changes)

* Mon Jun 20 2011 Paul Howarth <paul@city-fan.org> - 2.036-1
- Update to 2.036 (added offset parameter to CRC32)

* Sat May  7 2011 Paul Howarth <paul@city-fan.org> - 2.035-1
- Update to 2.035 (no changes)

* Tue May  3 2011 Paul Howarth <paul@city-fan.org> - 2.034-1
- Update to 2.034 (some changes to tests)
- Nobody else likes macros for commands

* Tue Jan 11 2011 Paul Howarth <paul@city-fan.org> - 2.033-1
- Update to 2.033 (fixed typos and spelling errors - Perl RT#81782)

* Fri Jan  7 2011 Paul Howarth <paul@city-fan.org> - 2.032-1
- Update to 2.032 (document inflateReset - CPAN RT#61082)

* Mon Jul 26 2010 Paul Howarth <paul@city-fan.org> - 2.030-1
- Update to 2.030
  - Ran the zlib2ansi script against the files in zlib-src
  - Added "-DNO_VIZ" to DEFINE in Makefile.PL (CPAN RT #58860)

* Wed Jun 23 2010 Paul Howarth <paul@city-fan.org> - 2.027-3
- Rebuild for perl 5.12.1 in Rawhide

* Sat Jun  5 2010 Paul Howarth <paul@city-fan.org> - 2.027-2
- Fix dist tag for RHEL-6 Beta

* Mon Apr 26 2010 Paul Howarth <paul@city-fan.org> - 2.027-1
- Update to 2.027 (bundled zlib is 1.2.5)

* Thu Apr  8 2010 Paul Howarth <paul@city-fan.org> - 2.026-1
- Update to 2.026
  - Fixed definition of Z_TREES in Makefile.PL (CPAN RT#56293)
  - Fixed build on Solaris (CPAN RT#56108)
- Revert to building with system zlib if it's version 1.2.1 or higher

* Sun Mar 28 2010 Paul Howarth <paul@city-fan.org> - 2.025-1
- Update to 2.025
  - Updated to include zlib 1.2.4
  - Allow zlib version check to be disabled (CPAN RT#54510)
  - Now need to build with bundled zlib unless we have zlib >= 1.2.4

* Mon Jan 11 2010 Paul Howarth <paul@city-fan.org> - 2.024-1
- Update to 2.024 (copyright dates updated; no functional changes)

* Mon Dec 21 2009 Paul Howarth <paul@city-fan.org> - 2.023-200
- Radically bump release to ensure that this package is RPM-newer than the
  bogus version in Rawhide that works around #544582 but is actually 2.020
- Dist tag for Rawhide no longer needs special-casing

* Tue Nov 10 2009 Paul Howarth <paul@city-fan.org> - 2.023-1
- Update to 2.023 (fix t/02zlib.t - CPAN RT#50765)
- Use %%{?perl_default_filter} for provides filter

* Tue Sep  1 2009 Paul Howarth <paul@city-fan.org> - 2.021-1
- Update to 2.021 (fix CPAN RT#47225 - cope with PERL5OPT=-MCarp=verbose)

* Thu Jun  4 2009 Paul Howarth <paul@city-fan.org> - 2.020-1
- Update to 2.020 (minor documentation change)

* Mon May  4 2009 Paul Howarth <paul@city-fan.org> - 2.019-1
- Import from Fedora
- Update to 2.019
- Use bundled zlib if system one is too old

* Wed Aug 29 2007 Fedora Release Engineering <rel-eng at fedoraproject dot org> - 2.005-3
- Rebuild for selinux ppc32 issue.

* Tue Jul 17 2007 Robin Norwood <rnorwood@redhat.com> - 2.005-2
- Bump release to beat F-7 version

* Sun Jul 01 2007 Robin Norwood <rnorwood@redhat.com> - 2.005-1
- Update to 2.005.

* Tue Jun 05 2007 Robin Norwood <rnorwood@redhat.com> - 2.004-1
- Initial build from CPAN
